module co_all_m
  implicit none
  
  interface
    module subroutine co_all(a)
      implicit none
      logical, intent(inout) :: a
    end subroutine
  end interface

end module

submodule(co_all_m) co_all_s
  implicit none
contains
  module procedure co_all
    call co_reduce(a, and)
  contains
    pure function and(lhs, rhs) result(lhs_and_rhs)
      logical, intent(in) :: lhs, rhs
      logical lhs_and_rhs
      lhs_and_rhs = lhs .and. rhs
    end function
    end procedure
end submodule

program main
  use co_all_m, only : co_all
  implicit none
  logical :: operand = .true.
  
  associate(me=>this_image())
    call co_all(operand)
    if (me==1) print *, operand
    if (me==num_images()) operand = .false.
    call co_all(operand)
    if (me==1) print *, operand
  end associate
end program
